include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom O : nat.
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (equal) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ).
definition eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((axiom_filter_nat_type_O) (return_type)) (return_)).
definition sym_eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) (return_ (O) ) ((filter_nat_type) (return_type) return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((eq_filter_nat_type_O) (return_type)) (return_)).
axiom plus : nat -> nat -> nat.
axiom plus_body : nat -> nat -> nat.
axiom axiom_plus : \forall (n:nat). (equal) (nat -> nat) ((plus)  n) ((filter_nat_type) (nat -> nat) (plus_body)  n).
definition eq_plus : \forall (n:nat). (leibniz) (nat -> nat) ((plus)  n) ((filter_nat_type) (nat -> nat) (plus_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((plus)  n)) ((filter_nat_type) (nat -> nat) (plus_body)  n)) ((axiom_plus) (n)).
definition sym_eq_plus : \forall (n:nat). (leibniz) (nat -> nat) ((filter_nat_type) (nat -> nat) (plus_body)  n) ((plus)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((plus)  n)) ((filter_nat_type) (nat -> nat) (plus_body)  n)) ((eq_plus) (n)).
axiom axiom_plus_body_O : (equal) (nat -> nat) ((plus_body)  (O) ) (\lambda m : nat. m).
definition eq_plus_body_O : (leibniz) (nat -> nat) ((plus_body)  (O) ) (\lambda m : nat. m) := ((((equal_leibniz) (nat -> nat)) ((plus_body)  (O) )) (\lambda m : nat. m)) (axiom_plus_body_O).
definition sym_eq_plus_body_O : (leibniz) (nat -> nat) (\lambda m : nat. m) ((plus_body)  (O) ) := ((((sym_leibniz) (nat -> nat)) ((plus_body)  (O) )) (\lambda m : nat. m)) (eq_plus_body_O).
definition plus_O_n : \forall (n:nat). (eq) (nat) n ((plus)  (O)  n) := \lambda n : nat. (((sym_eq_plus) ((O) )) (\lambda y : nat -> nat. (eq) (nat) n (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((plus_body) )) (\lambda y : nat -> nat. (eq) (nat) n (y n))) (((sym_eq_plus_body_O) (\lambda y : nat -> nat. (eq) (nat) n (y n))) (((refl) (nat)) (n)))).
